git-rebase.shon commit Merge branch 'en/rebase-i-microfixes' (b345b77)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20r,rebase-merges?   try to rebase merges instead of skipping them
  21p,preserve-merges! try to recreate merges instead of ignoring them
  22s,strategy=!       use the given merge strategy
  23no-ff!             cherry-pick all commits, even if unchanged
  24m,merge!           use merging strategies to rebase
  25i,interactive!     let the user edit the list of commits to rebase
  26x,exec=!           add exec lines after each commit of the editable list
  27k,keep-empty       preserve empty commits during rebase
  28allow-empty-message allow rebasing commits with empty messages
  29f,force-rebase!    force rebase even if branch is up to date
  30X,strategy-option=! pass the argument through to the merge strategy
  31stat!              display a diffstat of what changed upstream
  32n,no-stat!         do not show diffstat of what changed upstream
  33verify             allow pre-rebase hook to run
  34rerere-autoupdate  allow rerere to update index with resolved conflicts
  35root!              rebase all reachable commits up to the root(s)
  36autosquash         move commits that begin with squash!/fixup! under -i
  37committer-date-is-author-date! passed to 'git am'
  38ignore-date!       passed to 'git am'
  39signoff            passed to 'git am'
  40whitespace=!       passed to 'git apply'
  41ignore-whitespace! passed to 'git apply'
  42C=!                passed to 'git apply'
  43S,gpg-sign?        GPG-sign commits
  44 Actions:
  45continue!          continue
  46abort!             abort and check out the original branch
  47skip!              skip current patch and continue
  48edit-todo!         edit the todo list during an interactive rebase
  49quit!              abort but keep HEAD where it is
  50show-current-patch! show the patch file being applied or merged
  51"
  52. git-sh-setup
  53set_reflog_action rebase
  54require_work_tree_exists
  55cd_to_toplevel
  56
  57LF='
  58'
  59ok_to_skip_pre_rebase=
  60resolvemsg="
  61$(gettext 'Resolve all conflicts manually, mark them as resolved with
  62"git add/rm <conflicted_files>", then run "git rebase --continue".
  63You can instead skip this commit: run "git rebase --skip".
  64To abort and get back to the state before "git rebase", run "git rebase --abort".')
  65"
  66squash_onto=
  67unset onto
  68unset restrict_revision
  69cmd=
  70strategy=
  71strategy_opts=
  72do_merge=
  73merge_dir="$GIT_DIR"/rebase-merge
  74apply_dir="$GIT_DIR"/rebase-apply
  75verbose=
  76diffstat=
  77test "$(git config --bool rebase.stat)" = true && diffstat=t
  78autostash="$(git config --bool rebase.autostash || echo false)"
  79fork_point=auto
  80git_am_opt=
  81git_format_patch_opt=
  82rebase_root=
  83force_rebase=
  84allow_rerere_autoupdate=
  85# Non-empty if a rebase was in progress when 'git rebase' was invoked
  86in_progress=
  87# One of {am, merge, interactive}
  88type=
  89# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  90state_dir=
  91# One of {'', continue, skip, abort}, as parsed from command line
  92action=
  93rebase_merges=
  94rebase_cousins=
  95preserve_merges=
  96autosquash=
  97keep_empty=
  98allow_empty_message=
  99signoff=
 100test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
 101case "$(git config --bool commit.gpgsign)" in
 102true)   gpg_sign_opt=-S ;;
 103*)      gpg_sign_opt= ;;
 104esac
 105
 106read_basic_state () {
 107        test -f "$state_dir/head-name" &&
 108        test -f "$state_dir/onto" &&
 109        head_name=$(cat "$state_dir"/head-name) &&
 110        onto=$(cat "$state_dir"/onto) &&
 111        # We always write to orig-head, but interactive rebase used to write to
 112        # head. Fall back to reading from head to cover for the case that the
 113        # user upgraded git with an ongoing interactive rebase.
 114        if test -f "$state_dir"/orig-head
 115        then
 116                orig_head=$(cat "$state_dir"/orig-head)
 117        else
 118                orig_head=$(cat "$state_dir"/head)
 119        fi &&
 120        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 121        test -f "$state_dir"/verbose && verbose=t
 122        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 123        test -f "$state_dir"/strategy_opts &&
 124                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 125        test -f "$state_dir"/allow_rerere_autoupdate &&
 126                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 127        test -f "$state_dir"/gpg_sign_opt &&
 128                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 129        test -f "$state_dir"/signoff && {
 130                signoff="$(cat "$state_dir"/signoff)"
 131                force_rebase=t
 132        }
 133}
 134
 135write_basic_state () {
 136        echo "$head_name" > "$state_dir"/head-name &&
 137        echo "$onto" > "$state_dir"/onto &&
 138        echo "$orig_head" > "$state_dir"/orig-head &&
 139        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 140        test t = "$verbose" && : > "$state_dir"/verbose
 141        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 142        test -n "$strategy_opts" && echo "$strategy_opts" > \
 143                "$state_dir"/strategy_opts
 144        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 145                "$state_dir"/allow_rerere_autoupdate
 146        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 147        test -n "$signoff" && echo "$signoff" >"$state_dir"/signoff
 148}
 149
 150output () {
 151        case "$verbose" in
 152        '')
 153                output=$("$@" 2>&1 )
 154                status=$?
 155                test $status != 0 && printf "%s\n" "$output"
 156                return $status
 157                ;;
 158        *)
 159                "$@"
 160                ;;
 161        esac
 162}
 163
 164move_to_original_branch () {
 165        case "$head_name" in
 166        refs/*)
 167                message="rebase finished: $head_name onto $onto"
 168                git update-ref -m "$message" \
 169                        $head_name $(git rev-parse HEAD) $orig_head &&
 170                git symbolic-ref \
 171                        -m "rebase finished: returning to $head_name" \
 172                        HEAD $head_name ||
 173                die "$(eval_gettext "Could not move back to \$head_name")"
 174                ;;
 175        esac
 176}
 177
 178apply_autostash () {
 179        if test -f "$state_dir/autostash"
 180        then
 181                stash_sha1=$(cat "$state_dir/autostash")
 182                if git stash apply $stash_sha1 >/dev/null 2>&1
 183                then
 184                        echo "$(gettext 'Applied autostash.')" >&2
 185                else
 186                        git stash store -m "autostash" -q $stash_sha1 ||
 187                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 188                        gettext 'Applying autostash resulted in conflicts.
 189Your changes are safe in the stash.
 190You can run "git stash pop" or "git stash drop" at any time.
 191' >&2
 192                fi
 193        fi
 194}
 195
 196finish_rebase () {
 197        rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 198        apply_autostash &&
 199        { git gc --auto || true; } &&
 200        rm -rf "$state_dir"
 201}
 202
 203run_specific_rebase () {
 204        if [ "$interactive_rebase" = implied ]; then
 205                GIT_EDITOR=:
 206                export GIT_EDITOR
 207                autosquash=
 208        fi
 209        . git-rebase--$type
 210
 211        if test -z "$preserve_merges"
 212        then
 213                git_rebase__$type
 214        else
 215                git_rebase__preserve_merges
 216        fi
 217
 218        ret=$?
 219        if test $ret -eq 0
 220        then
 221                finish_rebase
 222        elif test $ret -eq 2 # special exit status for rebase -i
 223        then
 224                apply_autostash &&
 225                rm -rf "$state_dir" &&
 226                die "Nothing to do"
 227        fi
 228        exit $ret
 229}
 230
 231run_pre_rebase_hook () {
 232        if test -z "$ok_to_skip_pre_rebase" &&
 233           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 234        then
 235                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 236                die "$(gettext "The pre-rebase hook refused to rebase.")"
 237        fi
 238}
 239
 240test -f "$apply_dir"/applying &&
 241        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 242
 243if test -d "$apply_dir"
 244then
 245        type=am
 246        state_dir="$apply_dir"
 247elif test -d "$merge_dir"
 248then
 249        if test -d "$merge_dir"/rewritten
 250        then
 251                type=preserve-merges
 252                interactive_rebase=explicit
 253                preserve_merges=t
 254        elif test -f "$merge_dir"/interactive
 255        then
 256                type=interactive
 257                interactive_rebase=explicit
 258        else
 259                type=merge
 260        fi
 261        state_dir="$merge_dir"
 262fi
 263test -n "$type" && in_progress=t
 264
 265total_argc=$#
 266while test $# != 0
 267do
 268        case "$1" in
 269        --no-verify)
 270                ok_to_skip_pre_rebase=yes
 271                ;;
 272        --verify)
 273                ok_to_skip_pre_rebase=
 274                ;;
 275        --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
 276                test $total_argc -eq 2 || usage
 277                action=${1##--}
 278                ;;
 279        --onto=*)
 280                onto="${1#--onto=}"
 281                ;;
 282        --exec=*)
 283                cmd="${cmd}exec ${1#--exec=}${LF}"
 284                test -z "$interactive_rebase" && interactive_rebase=implied
 285                ;;
 286        --interactive)
 287                interactive_rebase=explicit
 288                ;;
 289        --keep-empty)
 290                keep_empty=yes
 291                ;;
 292        --allow-empty-message)
 293                allow_empty_message=--allow-empty-message
 294                ;;
 295        --no-keep-empty)
 296                keep_empty=
 297                ;;
 298        --rebase-merges)
 299                rebase_merges=t
 300                test -z "$interactive_rebase" && interactive_rebase=implied
 301                ;;
 302        --rebase-merges=*)
 303                rebase_merges=t
 304                case "${1#*=}" in
 305                rebase-cousins) rebase_cousins=t;;
 306                no-rebase-cousins) rebase_cousins=;;
 307                *) die "Unknown mode: $1";;
 308                esac
 309                test -z "$interactive_rebase" && interactive_rebase=implied
 310                ;;
 311        --preserve-merges)
 312                preserve_merges=t
 313                test -z "$interactive_rebase" && interactive_rebase=implied
 314                ;;
 315        --autosquash)
 316                autosquash=t
 317                ;;
 318        --no-autosquash)
 319                autosquash=
 320                ;;
 321        --fork-point)
 322                fork_point=t
 323                ;;
 324        --no-fork-point)
 325                fork_point=
 326                ;;
 327        --merge)
 328                do_merge=t
 329                ;;
 330        --strategy-option=*)
 331                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}" | sed -e s/^.//)"
 332                do_merge=t
 333                test -z "$strategy" && strategy=recursive
 334                ;;
 335        --strategy=*)
 336                strategy="${1#--strategy=}"
 337                do_merge=t
 338                ;;
 339        --no-stat)
 340                diffstat=
 341                ;;
 342        --stat)
 343                diffstat=t
 344                ;;
 345        --autostash)
 346                autostash=true
 347                ;;
 348        --no-autostash)
 349                autostash=false
 350                ;;
 351        --verbose)
 352                verbose=t
 353                diffstat=t
 354                GIT_QUIET=
 355                ;;
 356        --quiet)
 357                GIT_QUIET=t
 358                git_am_opt="$git_am_opt -q"
 359                verbose=
 360                diffstat=
 361                ;;
 362        --whitespace=*)
 363                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 364                case "${1#--whitespace=}" in
 365                fix|strip)
 366                        force_rebase=t
 367                        ;;
 368                esac
 369                ;;
 370        --ignore-whitespace)
 371                git_am_opt="$git_am_opt $1"
 372                ;;
 373        --signoff)
 374                signoff=--signoff
 375                ;;
 376        --no-signoff)
 377                signoff=
 378                ;;
 379        --committer-date-is-author-date|--ignore-date)
 380                git_am_opt="$git_am_opt $1"
 381                force_rebase=t
 382                ;;
 383        -C*)
 384                git_am_opt="$git_am_opt $1"
 385                ;;
 386        --root)
 387                rebase_root=t
 388                ;;
 389        --force-rebase|--no-ff)
 390                force_rebase=t
 391                ;;
 392        --rerere-autoupdate|--no-rerere-autoupdate)
 393                allow_rerere_autoupdate="$1"
 394                ;;
 395        --gpg-sign)
 396                gpg_sign_opt=-S
 397                ;;
 398        --gpg-sign=*)
 399                gpg_sign_opt="-S${1#--gpg-sign=}"
 400                ;;
 401        --)
 402                shift
 403                break
 404                ;;
 405        *)
 406                usage
 407                ;;
 408        esac
 409        shift
 410done
 411test $# -gt 2 && usage
 412
 413if test -n "$action"
 414then
 415        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 416        # Only interactive rebase uses detailed reflog messages
 417        if test -n "$interactive_rebase" && test "$GIT_REFLOG_ACTION" = rebase
 418        then
 419                GIT_REFLOG_ACTION="rebase -i ($action)"
 420                export GIT_REFLOG_ACTION
 421        fi
 422fi
 423
 424if test "$action" = "edit-todo" && test -z "$interactive_rebase"
 425then
 426        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 427fi
 428
 429case "$action" in
 430continue)
 431        # Sanity check
 432        git rev-parse --verify HEAD >/dev/null ||
 433                die "$(gettext "Cannot read HEAD")"
 434        git update-index --ignore-submodules --refresh &&
 435        git diff-files --quiet --ignore-submodules || {
 436                echo "$(gettext "You must edit all merge conflicts and then
 437mark them as resolved using git add")"
 438                exit 1
 439        }
 440        read_basic_state
 441        run_specific_rebase
 442        ;;
 443skip)
 444        output git reset --hard HEAD || exit $?
 445        read_basic_state
 446        run_specific_rebase
 447        ;;
 448abort)
 449        git rerere clear
 450        read_basic_state
 451        case "$head_name" in
 452        refs/*)
 453                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 454                die "$(eval_gettext "Could not move back to \$head_name")"
 455                ;;
 456        esac
 457        output git reset --hard $orig_head
 458        finish_rebase
 459        exit
 460        ;;
 461quit)
 462        exec rm -rf "$state_dir"
 463        ;;
 464edit-todo)
 465        run_specific_rebase
 466        ;;
 467show-current-patch)
 468        run_specific_rebase
 469        die "BUG: run_specific_rebase is not supposed to return here"
 470        ;;
 471esac
 472
 473# Make sure no rebase is in progress
 474if test -n "$in_progress"
 475then
 476        state_dir_base=${state_dir##*/}
 477        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 478        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 479        die "
 480$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 481I wonder if you are in the middle of another rebase.  If that is the
 482case, please try
 483        $cmd_live_rebase
 484If that is not the case, please
 485        $cmd_clear_stale_rebase
 486and run me again.  I am stopping in case you still have something
 487valuable there.')"
 488fi
 489
 490if test -n "$rebase_root" && test -z "$onto"
 491then
 492        test -z "$interactive_rebase" && interactive_rebase=implied
 493fi
 494
 495if test -n "$keep_empty"
 496then
 497        test -z "$interactive_rebase" && interactive_rebase=implied
 498fi
 499
 500if test -n "$interactive_rebase"
 501then
 502        if test -z "$preserve_merges"
 503        then
 504                type=interactive
 505        else
 506                type=preserve-merges
 507        fi
 508
 509        state_dir="$merge_dir"
 510elif test -n "$do_merge"
 511then
 512        type=merge
 513        state_dir="$merge_dir"
 514else
 515        type=am
 516        state_dir="$apply_dir"
 517fi
 518
 519if test -t 2 && test -z "$GIT_QUIET"
 520then
 521        git_format_patch_opt="$git_format_patch_opt --progress"
 522fi
 523
 524if test -n "$signoff"
 525then
 526        test -n "$preserve_merges" &&
 527                die "$(gettext "error: cannot combine '--signoff' with '--preserve-merges'")"
 528        git_am_opt="$git_am_opt $signoff"
 529        force_rebase=t
 530fi
 531
 532if test -z "$rebase_root"
 533then
 534        case "$#" in
 535        0)
 536                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 537                        --verify -q @{upstream} 2>/dev/null)
 538                then
 539                        . git-parse-remote
 540                        error_on_missing_default_upstream "rebase" "rebase" \
 541                                "against" "git rebase $(gettext '<branch>')"
 542                fi
 543
 544                test "$fork_point" = auto && fork_point=t
 545                ;;
 546        *)      upstream_name="$1"
 547                if test "$upstream_name" = "-"
 548                then
 549                        upstream_name="@{-1}"
 550                fi
 551                shift
 552                ;;
 553        esac
 554        upstream=$(peel_committish "${upstream_name}") ||
 555        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 556        upstream_arg="$upstream_name"
 557else
 558        if test -z "$onto"
 559        then
 560                empty_tree=$(git hash-object -t tree /dev/null)
 561                onto=$(git commit-tree $empty_tree </dev/null)
 562                squash_onto="$onto"
 563        fi
 564        unset upstream_name
 565        unset upstream
 566        test $# -gt 1 && usage
 567        upstream_arg=--root
 568fi
 569
 570# Make sure the branch to rebase onto is valid.
 571onto_name=${onto-"$upstream_name"}
 572case "$onto_name" in
 573*...*)
 574        if      left=${onto_name%...*} right=${onto_name#*...} &&
 575                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 576        then
 577                case "$onto" in
 578                ?*"$LF"?*)
 579                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 580                        ;;
 581                '')
 582                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 583                        ;;
 584                esac
 585        else
 586                die "$(eval_gettext "\$onto_name: there is no merge base")"
 587        fi
 588        ;;
 589*)
 590        onto=$(peel_committish "$onto_name") ||
 591        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 592        ;;
 593esac
 594
 595# If the branch to rebase is given, that is the branch we will rebase
 596# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 597# $orig_head -- commit object name of tip of the branch before rebasing
 598# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 599switch_to=
 600case "$#" in
 6011)
 602        # Is it "rebase other $branchname" or "rebase other $commit"?
 603        branch_name="$1"
 604        switch_to="$1"
 605
 606        # Is it a local branch?
 607        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 608           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 609        then
 610                head_name="refs/heads/$branch_name"
 611        # If not is it a valid ref (branch or commit)?
 612        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 613        then
 614                head_name="detached HEAD"
 615
 616        else
 617                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 618        fi
 619        ;;
 6200)
 621        # Do not need to switch branches, we are already on it.
 622        if branch_name=$(git symbolic-ref -q HEAD)
 623        then
 624                head_name=$branch_name
 625                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 626        else
 627                head_name="detached HEAD"
 628                branch_name=HEAD
 629        fi
 630        orig_head=$(git rev-parse --verify HEAD) || exit
 631        ;;
 632*)
 633        die "BUG: unexpected number of arguments left to parse"
 634        ;;
 635esac
 636
 637if test "$fork_point" = t
 638then
 639        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 640                        "${switch_to:-HEAD}")
 641        if test -n "$new_upstream"
 642        then
 643                restrict_revision=$new_upstream
 644        fi
 645fi
 646
 647if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 648then
 649        stash_sha1=$(git stash create "autostash") ||
 650        die "$(gettext 'Cannot autostash')"
 651
 652        mkdir -p "$state_dir" &&
 653        echo $stash_sha1 >"$state_dir/autostash" &&
 654        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 655        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 656        git reset --hard
 657fi
 658
 659require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 660
 661# Now we are rebasing commits $upstream..$orig_head (or with --root,
 662# everything leading up to $orig_head) on top of $onto
 663
 664# Check if we are already based on $onto with linear history,
 665# but this should be done only when upstream and onto are the same
 666# and if this is not an interactive rebase.
 667mb=$(git merge-base "$onto" "$orig_head")
 668if test -z "$interactive_rebase" && test "$upstream" = "$onto" &&
 669        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 670        # linear history?
 671        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 672then
 673        if test -z "$force_rebase"
 674        then
 675                # Lazily switch to the target branch if needed...
 676                test -z "$switch_to" ||
 677                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 678                        git checkout -q "$switch_to" --
 679                if test "$branch_name" = "HEAD" &&
 680                         ! git symbolic-ref -q HEAD
 681                then
 682                        say "$(eval_gettext "HEAD is up to date.")"
 683                else
 684                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 685                fi
 686                finish_rebase
 687                exit 0
 688        else
 689                if test "$branch_name" = "HEAD" &&
 690                         ! git symbolic-ref -q HEAD
 691                then
 692                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 693                else
 694                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 695                fi
 696        fi
 697fi
 698
 699# If a hook exists, give it a chance to interrupt
 700run_pre_rebase_hook "$upstream_arg" "$@"
 701
 702if test -n "$diffstat"
 703then
 704        if test -n "$verbose"
 705        then
 706                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 707        fi
 708        # We want color (if set), but no pager
 709        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 710fi
 711
 712test -n "$interactive_rebase" && run_specific_rebase
 713
 714# Detach HEAD and reset the tree
 715say "$(gettext "First, rewinding head to replay your work on top of it...")"
 716
 717GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 718        git checkout -q "$onto^0" || die "could not detach HEAD"
 719git update-ref ORIG_HEAD $orig_head
 720
 721# If the $onto is a proper descendant of the tip of the branch, then
 722# we just fast-forwarded.
 723if test "$mb" = "$orig_head"
 724then
 725        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 726        move_to_original_branch
 727        finish_rebase
 728        exit 0
 729fi
 730
 731if test -n "$rebase_root"
 732then
 733        revisions="$onto..$orig_head"
 734else
 735        revisions="${restrict_revision-$upstream}..$orig_head"
 736fi
 737
 738run_specific_rebase